/*
 * r2fib.c: Compute Fibonacci numbers using a doubly recursive algorithm,
 *	using the C "unsigned long" data type.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Copyright (c) 2009 Paul E. McKenney, IBM Corporation.
 */

#include <stdio.h>
#include <stdlib.h>

unsigned long fib(int x)
{
	if (x <= 2) {
		if (x < 0)
			return fib(-x);
		return 1;
	}
	return fib(x - 1) + fib(x - 2);
}

int main(int argc, char *argv[])
{
	int i;
	int x;

	if (argc != 2) {
		fprintf(stderr, "%s i\n", argv[0]);
		exit(-1);
	}
	x = atoi(argv[1]);

	printf("fib(%d) = %lu\n", x, fib(x));
	return 0;
}
